package Ausfgabe2;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

public class EchoThread extends Thread {
	Socket sock;
	String username;
	static List<EchoThread> syncList = Collections.synchronizedList(new LinkedList<EchoThread>());

	/**
	 * 
	 * @param sock
	 */
	public EchoThread(Socket sock) {
		this.sock = sock;
		EchoThread.syncList.add(this);
	}

	@Override
	public void run() {
		try {
			BufferedReader netIn = new BufferedReader(new InputStreamReader(
					sock.getInputStream()));
			BufferedWriter netOut = new BufferedWriter(new OutputStreamWriter(
					sock.getOutputStream())); 
			username=netIn.readLine();
			
			
			synchronized(EchoThread.syncList){
				
				for(EchoThread eT : EchoThread.syncList ){
					
					BufferedWriter out =new BufferedWriter(new OutputStreamWriter(eT.sock.getOutputStream()));
					if(!eT.sock.equals(sock)){
						out.write(username+" betritt den Server."+"\n");
						out.flush();
					}
					if(!eT.username.equals(username)){
						netOut.write(eT.username+" ist schon dabei."+"\n");
						netOut.flush();
					}
				}
			}
					
			
			String line;
			while ((line = netIn.readLine()) != null) {
				if (line.startsWith("/quit")){
					
					break;
					
				}
				synchronized(EchoThread.syncList){
		
					for(EchoThread eT : EchoThread.syncList){
						BufferedWriter out =new BufferedWriter(new OutputStreamWriter(eT.sock.getOutputStream()));
						out.write(username+": "+line + "\n");
						out.flush();
						
					}
				}
				
			}
			
			synchronized(EchoThread.syncList){
				
				for(EchoThread echo : EchoThread.syncList){
					
					BufferedWriter out =new BufferedWriter(new OutputStreamWriter(echo.sock.getOutputStream()));
					if(!echo.sock.equals(sock)){
						out.write(username+" verlsst den Server."+"\n");
						out.flush();
					}
				}
			}
			
			
			
			EchoThread.syncList.remove(this);
			sock.shutdownInput();
			sock.shutdownOutput();
			sock.close();
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
